<template>
<div class="background">
  <v-container fluid fill-height>
    <v-layout align-center justify-center>
      <v-flex xs-12 sm8 md4>
        <v-card elevation="12">
          <v-toolbar dark>
            <v-toolbar-title>Вход в аккаунт</v-toolbar-title>
          </v-toolbar>
          <v-form
            @submit.prevent="signin"
            ref="form"
            v-model="valid"
            lazy-validation
          >
            <v-card-text>
              <v-text-field
                prepend-icon="mdi-account"
                v-model="email"
                :rules="emailRules"
                label="e-mail"
                type="email"
                :error-messages="error"
                required
                @focus="resetValidation"
              ></v-text-field>
              <v-text-field
                v-model="password"
                :rules="passwordRules"
                prepend-icon="mdi-lock"
                name="password"
                label="Пароль"
                type="password"
                required
                @focus="resetValidation"
              ></v-text-field>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn dark type="submit">Войти</v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-flex>
    </v-layout>
  </v-container>
</div>
</template>
<script>
export default {
  data() {
    return {
      email: "",
      error: "",
      password: "",
      valid: true,
      emailRules: [
        (v) => !!v || "E-mail is required",
        (v) => /.+@.+\..+/.test(v) || "E-mail must be valid",
      ],
      passwordRules: [
        (v) => !!v || "password is required",
        (v) =>
          (v && v.length >= 5) || "Password must be more than 5 characters",
      ],
    };
  },
  methods: {
    resetValidation() {
      this.error = "";
      this.$refs.form.resetValidation();
    },
    signin() {
      if (!this.$refs.form.validate()) return;
      let email = this.email;
      let password = this.password;

      this.$store
        .dispatch("userModule/signin", { email, password })
        .then(() => {
          const { to } = this.$router.currentRoute.params;
          this.$router.push(to ? to.path : "/");
        })
        .catch((err) => (this.error = err.message || "Something goes wrong"));
    },
  },
};
</script>
<style></style>
